#include <Arduino.h>
#include <Wire.h>

#include "constants.h"
#include "buzzer.h"
#include "screen.h"
#include "keyboard.h"
#include "encoder.h"
#include "debug.h"
#include "stepper.h"
#include "memes.h"
#include "input.h"
#include "spindle.h"
#include "menu.h"

void setup() {
  setupDebug();
  setupEncoder();
  if (!setupStepper()) {
    fatal();
  }

  Wire.begin();
  Wire.setClock(800000);
  debugScanI2C();

  if (!setupScreen()) {
    fatal();
  }
  if (!setupKeyboard()) {
    fatal();
  }
  if (!setupSpindle()) {
    fatal();
  }

  splashScreen();
  menu();
}

void loop() {
}

